/**********************************************************************
 *
 * Function HLT_COMM()
 *
 *  hlt_comm     - -
 * ,   .
 *
 * :
 *       
 *  ,    .
 *
 * 1. .
 * *  :
 * - OTKCOM := "/" + "*";
 * - ZAKCOM := "*" + "/";
 * - KONCOM := "/" + "/";
 * *   := 0.
 * *     .
 * 2.         
 *      .   . 
 *      --   .
 * 3.  :
 *
 * 4. OTKCOM ( ).    :
 *                                     2,  := mod (++/2);
 * 5. ZAKCOM ( ):
 *                                     3,  := mod (++/2);
 * 6. KONCOM (    ):
 *                                     1,   ;
 * 7.       :
 *                                     0,   .
 * 8.    (    )
 *           ,
 *         (. 9.).
 * 9.   == 1   == 2 (  
 *     OTKCOM) :
 * *        .
 * *   .
 * *   OTKCOM     2.
 * 10.   == 0   == 3 ( 
 *      --  ZAKCOM), :
 * *        .
 * *         . 2.
 * 11.   == 0   == 2 ( 
 *        ), :
 * *        .2.
 * 12.   == 1   3 ( 
 *     ""   ZAKCOM), :
 * *        .2.
 * 13.   == 1   0 (  ), 
 * *   .   . 2.
 * 14.   == 0   0 (  ), 
 * *   .   . 2.
 * 15.   == 0   == 1 (  
 *     KONCOM   ), :
 * *        .
 * *   .
 * *    ,   .
 * *   . 2
 * 16.   == 1   = 1 (  
 *     KONCOM  ), 
 * *   .   . 2.
 * 17.  .
 * 18.  .
 *
 *  :
 * * .
 *
 *  :
 * * .
 *
 *  :
 *
 * * TOF
 * * AT_EOF
 * * SEARCH_FWD
 * * UP
 * * DOWN
 * * DEL_LINE
 * * GOTO_COL
 * * RIGHT
 * * DEL_CHAR
 *
**********************************************************************/
void hlt_comm()
{

/*  */

  str OTKCOM[2], ZAKCOM[2], KONCOM[2];
  int COND, PRIZN;
  IGNORE_CASE=TRUE;
  REG_EXP_STAT=FALSE;
  COND = 0;
  OTKCOM = "/" + "*";
  ZAKCOM = "*" + "/";
  KONCOM= "/" + "/";
  TOF;

/*   */

  WHILE(!AT_EOF)
  {

/*  1 */
    IF( SEARCH_FWD(OTKCOM,1)==TRUE )
    {
      PRIZN = 2;
      COND = (COND+1)%2;
      GOTO RULE;
    }
/*  2 */
    IF( SEARCH_FWD(ZAKCOM,1)==TRUE )
    {
      PRIZN = 3;
      COND = (COND+1)%2;
      GOTO RULE;
    }
/*  3 */
    IF( SEARCH_FWD(KONCOM,1)==TRUE )
    {
      PRIZN = 1;
      GOTO RULE;
    }

/*  4 () */
    PRIZN = 0;
    GOTO RULE;

    RULE:;

/* :
 * 1.   == 1   == 2 (  
 *     OTKCOM) :
 * *        .
 * *   .
 * *   OTKCOM     2.
*/
    IF( (COND == 1) && (PRIZN == 2) )
    {
       CR;
       UP;
       DEL_LINE;
       GOTO_COL( 3 );
       GOTO CONT;
    }

/* :
 * 4.   == 1   3 ( 
 *    ""   ZAKCOM), :
 * *        .2.
*/
    IF( (COND == 1) && (PRIZN == 3) )
    {
       DEL_CHAR;DEL_CHAR;
       GOTO_COL( 1 );
       GOTO CONT;
    }

/* :
 * 5.   == 1   0 (  ), 
 * *    .   . 2.
*/
    IF( (COND == 1) && (PRIZN == 0) )
    {
       DOWN;
       GOTO_COL( 1 );
       GOTO CONT;
    }

/* :
 * 8.   == 1   = 1 (  
 *    KONCOM  ), 
 * *   .   . 2.
*/
    IF( (COND == 1) && (PRIZN == 1) )
    {
       DEL_CHAR; DEL_CHAR;
       GOTO_COL( 1 );
       GOTO CONT;
    }

/* :
 * 2.   == 0   == 3 ( 
 *     --  ZAKCOM), :
 * *        .
 * *         . 2.
*/
    IF( (COND == 0) && (PRIZN == 3) )
    {
       RIGHT;RIGHT;
       CR;
       GOTO_COL( 1 );
       GOTO CONT;
    }

/* :
 * 3.   == 0   == 2 ( 
 *       ), :
 * *        .2.
*/
    IF( (COND == 0) && (PRIZN == 2) )
    {
       DEL_CHAR; DEL_CHAR;
       GOTO_COL( 1 );
       GOTO CONT;
    }

/* :
 * 6.   == 0   0 (  ), 
 * *   .   . 2.
*/
    IF( (COND == 0) && (PRIZN == 0) )
    {
       DEL_LINE;
       GOTO_COL( 1 );
       GOTO CONT;
    }

/* :
 * 7.   == 0   == 1 (  
 *    KONCOM   ), :
 * *        .
 * *   .
 * *    ,   .
 * *   . 2
***/
    IF( (COND == 0) && (PRIZN == 1) )
    {
       CR;
       UP;
       DEL_LINE;
       DOWN;
       GOTO_COL( 1 );
       GOTO CONT;
    }

    CONT:;
  }
/*   */
}
/*   */

/**********************************************************************
 *
 *     ,
 *    .
 *
 * .      
 *     ,   
 *   .
 *      :
 *
 *
 * 1.       ,
 *        .
 * 2.        . 
 *       !    
 *       RULE -- ,    
 *         () 
 *        .
 * 3.         ""
 *    --   ,   
 *      (      ).
 *         , 
 *      RULE.
 * 4.        
 *     ! ,   ,  
 *          ,  , 
 *       ,   .
 * 5.      ""
 *    (       ),
 *     ,       
 *     ( ) .
 * 6.  ,     (, 
 *     (0  1),     
 *        (,  
 *         1,  
 *         0),  
 *        :
 *
 *                         COND := (++COND)%2, 
 *
 * - COND --  (  0  1),
 * - ++ --   (   1),
 * - % --      (    2).
 *          COND 
 *      ,      
 *    .
 *    .  --  ,  
 *          
 *     (,    ,  
 *         ).   
 *          .
 * 7.      ( 
 *       ),    
 *       ,   .
 *          CONT. -,
 *           .
 * 8.     (  ) 
 *     .
 *
***********************************************************************/
